package com.helpdesk.micaficito.modelos;
// Generated 11-dic-2019 11:52:12 by Hibernate Tools 4.3.1


import java.util.Date;
import java.util.HashSet;
import java.util.Set;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.UniqueConstraint;

/**
 * Taxes generated by hbm2java
 */
@Entity
@Table(name="taxes"
    ,catalog="openbravopos"
    , uniqueConstraints = @UniqueConstraint(columnNames="NAME") 
)
public class Taxes  implements java.io.Serializable {


     private String id;
     private Taxcategories taxcategories;
     private Taxcustcategories taxcustcategories;
     private Taxes taxes;
     private String name;
     private Date validfrom;
     private double rate;
     private boolean ratecascade;
     private Integer rateorder;
     private Set<Taxlines> taxlineses = new HashSet<Taxlines>(0);
     private Set<Ticketlines> ticketlineses = new HashSet<Ticketlines>(0);
     private Set<Taxes> taxeses = new HashSet<Taxes>(0);

    public Taxes() {
    }

	
    public Taxes(String id, Taxcategories taxcategories, String name, Date validfrom, double rate, boolean ratecascade) {
        this.id = id;
        this.taxcategories = taxcategories;
        this.name = name;
        this.validfrom = validfrom;
        this.rate = rate;
        this.ratecascade = ratecascade;
    }
    public Taxes(String id, Taxcategories taxcategories, Taxcustcategories taxcustcategories, Taxes taxes, String name, Date validfrom, double rate, boolean ratecascade, Integer rateorder, Set<Taxlines> taxlineses, Set<Ticketlines> ticketlineses, Set<Taxes> taxeses) {
       this.id = id;
       this.taxcategories = taxcategories;
       this.taxcustcategories = taxcustcategories;
       this.taxes = taxes;
       this.name = name;
       this.validfrom = validfrom;
       this.rate = rate;
       this.ratecascade = ratecascade;
       this.rateorder = rateorder;
       this.taxlineses = taxlineses;
       this.ticketlineses = ticketlineses;
       this.taxeses = taxeses;
    }
   
     @Id 

    
    @Column(name="ID", unique=true, nullable=false)
    public String getId() {
        return this.id;
    }
    
    public void setId(String id) {
        this.id = id;
    }

@ManyToOne(fetch=FetchType.LAZY)
    @JoinColumn(name="CATEGORY", nullable=false)
    public Taxcategories getTaxcategories() {
        return this.taxcategories;
    }
    
    public void setTaxcategories(Taxcategories taxcategories) {
        this.taxcategories = taxcategories;
    }

@ManyToOne(fetch=FetchType.LAZY)
    @JoinColumn(name="CUSTCATEGORY")
    public Taxcustcategories getTaxcustcategories() {
        return this.taxcustcategories;
    }
    
    public void setTaxcustcategories(Taxcustcategories taxcustcategories) {
        this.taxcustcategories = taxcustcategories;
    }

@ManyToOne(fetch=FetchType.LAZY)
    @JoinColumn(name="PARENTID")
    public Taxes getTaxes() {
        return this.taxes;
    }
    
    public void setTaxes(Taxes taxes) {
        this.taxes = taxes;
    }

    
    @Column(name="NAME", unique=true, nullable=false)
    public String getName() {
        return this.name;
    }
    
    public void setName(String name) {
        this.name = name;
    }

    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="VALIDFROM", nullable=false, length=19)
    public Date getValidfrom() {
        return this.validfrom;
    }
    
    public void setValidfrom(Date validfrom) {
        this.validfrom = validfrom;
    }

    
    @Column(name="RATE", nullable=false, precision=22, scale=0)
    public double getRate() {
        return this.rate;
    }
    
    public void setRate(double rate) {
        this.rate = rate;
    }

    
    @Column(name="RATECASCADE", nullable=false)
    public boolean isRatecascade() {
        return this.ratecascade;
    }
    
    public void setRatecascade(boolean ratecascade) {
        this.ratecascade = ratecascade;
    }

    
    @Column(name="RATEORDER")
    public Integer getRateorder() {
        return this.rateorder;
    }
    
    public void setRateorder(Integer rateorder) {
        this.rateorder = rateorder;
    }

@OneToMany(fetch=FetchType.LAZY, mappedBy="taxes")
    public Set<Taxlines> getTaxlineses() {
        return this.taxlineses;
    }
    
    public void setTaxlineses(Set<Taxlines> taxlineses) {
        this.taxlineses = taxlineses;
    }

@OneToMany(fetch=FetchType.LAZY, mappedBy="taxes")
    public Set<Ticketlines> getTicketlineses() {
        return this.ticketlineses;
    }
    
    public void setTicketlineses(Set<Ticketlines> ticketlineses) {
        this.ticketlineses = ticketlineses;
    }

@OneToMany(fetch=FetchType.LAZY, mappedBy="taxes")
    public Set<Taxes> getTaxeses() {
        return this.taxeses;
    }
    
    public void setTaxeses(Set<Taxes> taxeses) {
        this.taxeses = taxeses;
    }




}


